#pragma once
namespace DrawingLayer 
{
    [WebHostHidden]
	public interface class IShapeGeometry
    {
        void BeginFigure(Point start, bool isFilled);
        void AddLine(Point point);
        void EndFigure(bool close);
    };

    [WebHostHidden]
    public interface class IRenderer
	{
		property int TargetWidth { int get(); }
		property int TargetHeight { int get(); }
		property ImageBrush^ TargetBrush { ImageBrush^ get(); }
		property bool EnableMotionBlur { bool get(); void set(bool value); }
		property float MotionBlurAngle { float get(); void set(float value); }
		property float MotionBlurDeviation { float get(); void set(float value); }
		
		void Reset(int width, int height);
		void BeginDraw();
		void EndDraw();
		void Clear(Color color);
        IShapeGeometry^ CreateGeometry();
        void DrawGeometry(IShapeGeometry^ geometry, Color color, float width);
        void FillGeometry(IShapeGeometry^ geometry, Color color);
	};
}