#pragma once

namespace DrawingLayer
{
    private ref class ShapeGeometry : public IShapeGeometry
    {
    private:
        ComPtr<ID2D1PathGeometry1>  m_d2dGeometry;
        ComPtr<ID2D1GeometrySink>   m_d2dSink;

    internal:
        ShapeGeometry(ID2D1PathGeometry1* geometry);

    private:
        D2D1_POINT_2F GetD2DPoint(Point point);

    public:
		virtual void BeginFigure(Point start, bool isFilled);
        virtual void AddLine(Point point);
        virtual void EndFigure(bool close);

    internal:
        void Fill(ID2D1DeviceContext* d2dContext, D2D1_COLOR_F color);
        void Draw(ID2D1DeviceContext* d2dContext, D2D1_COLOR_F color, float width);
    };
}

